// This program only works as written if you have all the hardware described in
// the book, Arlo: The Robot You've Always Wanted (available on Amazon.com)
// The book provides details for building your own Arlo plus descriptions
// of the algorithms used so you can modify or build Arlo with different hardware.
// Note: This program also requires specific programs to be running or available
// in the root directory - see the book for complete details.

main: 
  gosub InitAll 
  while true
    gosub CheckForVoiceCommand
    if InString(VoiceIn, "PROGRAM") then break  // end program     
    if InString(VoiceIn, "LEARN")      //Learn colors, Learn objectsi    
      gosub LearnColors
    elseif Instring(VoiceIn,"ARLO") \
      or Instring(VoiceIn,"I LOVE")   //ARLO
      call Say("Yes john     what can I do for you", happy)
    elseif Instring(VoiceIn, "GOOD")
      call Say("I am glad you liked it", happy)
    elseif InString(VoiceIn, "DEMO")   //Demo your emotions, do a face demo
      gosub DemoFace
    elseif Instring(VoiceIn, "NORTH")  //turn north, face north
      gosub TurnNorth
    elseif Instring(VoiceIn, "SOUTH")  //turn south, face south
      gosub TurnSouth
    elseif Instring(VoiceIn, "EAST")   //turn east, face east
      gosub TurnEast
    elseif Instring(VoiceIn, "WEST")   //turn west, face west
      gosub TurnWest
    elseif Instring(VoiceIn, "FORWARD")//move forward, forward please 
      gosub MoveForward
    elseif Instring(VoiceIn, "BACK")   //move back, move backward, backup
      gosub MoveBackward
    elseif Instring(VoiceIn, "LEFT")   //turn to your left, turn left
      gosub TurnLeft    
    elseif Instring(VoiceIn, "RIGHT")  //turn to your right, turn right
      gosub TurnRight
    elseif Instring(VoiceIn, "COME")   //come here, come to me
      gosub ComeToMe
    elseif Instring(VoiceIn, "MUCH")   //not so much, still too much
      gosub DoLess
    elseif Instring(VoiceIn, "MORE")   //a little more, do more
      gosub DoMore
    elseif Instring(VoiceIn, "LOOK") or \
      Instring(VoiceIn, "WATCH")  //look at this, look here, watch this please
      gosub WatchObject
    elseif Instring(VoiceIn, "CAMERA") or \
      Instring(VoiceIn, "ADJUST")
      gosub AdjustCamera
    elseif Instring(VoiceIn, "THANK YOU")
      call Say("You are welcome",happy)      
    elseif Instring(VoiceIn, "TABLE")  // put that on the table
      gosub ToTable 
    elseif Instring(VoiceIn, "GIVE")   // give me the bottle
      gosub GiveToMe
    elseif Instring(VoiceIn, "GREEN")  // pickup green bottle
      call PickUpBottle(GreenObject,Successful)
      gosub DropArms  
    elseif Instring(VoiceIn, "PINK") or \
      Instring(VoiceIn, "THANK")   // pickup pink bottle
      call PickUpBottle(PinkObject,Successful)
      gosub DropArms  
    elseif Instring(VoiceIn, "WHICH") or Instring(VoiceIn,"IDENTIF") 
      gosub IdentifyObject             //identify this, which bottle is this         
    elseif Instring(VoiceIn, "PICKUP") \
        or Instring(VoiceIn, "BOTTLE") // pickup the bottle, pickup the object
      gosub PickUpAnyBottle
      gosub DropArms
    elseif Instring(VoiceIn,"SCAN") \
        or Instring(VoiceIn,"STAN")  // show me a scan, scan ahead  
      gosub DoScan                       
    elseif Instring(VoiceIn, "AGAIN") \
        or Instring(VoiceIn,"REPEAT")   //do that again, repeat please
      gosub DoAgain                    
    elseif Instring(VoiceIn, "KITCHEN")//go to the kitchen, move to kitchen 
      Dest=Kitchen                     
      gosub MoveToDest
    elseif Instring(VoiceIn, "POOL TABLE") // go to pool table, move to pool table
      Dest=PoolTable
      gosub MoveToDest
      // add your destinations here
    elseif Instring(VoiceIn, "TABLE") // Place the bottle on the table
      gosub PlaceBottle
    elseif Instring(VoiceIn, "GUARD")  //guard the house, guard while I am gone
      gosub GuardTheHouse
    elseif Instring(VoiceIn, "WHO")    //who are you
      gosub Greeting
    elseif Instring(VoiceIn,"WAYNE") \
      or Instring(VoiceIn,"WAVE")   //wave to me, please wave  
      gosub DoWave                    
    elseif Instring(VoiceIn,"TAKE")// take this
      gosub TakeThis
    elseif Instring(VoiceIn, "OK")
      call Say("oh",normal)
      call Say("good",happy)
    elseif Instring(VoiceIn, "POLITE") // you are very polite
      call Say("I try to be nice", normal)
      call Say("You taught me well",happy)
    endif 
  wend
  call Say("Program will end now.    Goodbye", normal)
end

InitAll:
  scrsetmetrics ,,,,0,1
  call InitSensors(0,0,0,0)  
  gosub InitAnimateSay   
  gosub InitVoiceRec   
  gosub InitCameras 
  gosub InitArmData  
  data YforScan;  95,140,170,180,170,140,95
  data XforScan; 285,310,350,400,450,490,515 
  #include "RROScommands.bas"
  gosub InitRROScommands
  rCommPort 8
  rLocate ARLO,0
  rCommand(SetCompassType,HMC6352) // or to the HMC5883 
  rCommand(SetRobotAngle,84) // makes the wall NORTH
  rCommand(SetTurnStyle,30)  
  OnLeft = 0  // for wall follow behaviors
  OnRight = 1
  Wall = 1
  Door = 2   
return

sub InitSensors(a,b,c,d)                   
  // The Utility MUST reside in the same directory as
  // the application unless you set up paths 
  print "Initializing..."
  SetCBtext("stop") // stop utility if running
  filerename ("RBsTurn.txt","SensorsTurn.txt")
  delay 100
  Spawn ("RBsensorUtility.exe","",P_NOWAIT) 
  // provide time for Utility to spawn
  delay 1000 
  ClearScr   
  //  The above code can be eliminated if you always
  //  start the Utility manually. We have code in
  //  the utility that SHOULD prevent a second copy
  //  from running - but for some unknown reason it
  //  is not 100% reliable.  The above code seems to
  //  always work on our machine.
  dim Sensors[28] //max available from utility
  dim Offsets[4]                 
  for i=0 to 27
    Sensors[i]=""
  next
  // allow setting certain angles to zero
  Offsets[0]=a
  Offsets[1]=b
  Offsets[2]=c
  Offsets[3]=d  
return

InitAnimateSay:
  SpeechDelay=39 // adjust to time voice to animation
  MaxWords=20
  Dim words[MaxWords]
  horz = 0
  OldHorz = 0
  vert = 0
  OldVert = 0
  size = 0
  brows = 0
  mouth = 0
  normal = 0
  angry = 1
  sad = 2
  happy = 3
  surprise = 4
  noface = 5
  flip on
  gosub DrawFace
  Call Say("",normal) // Corrects animation timing on first use  
return

InitArmData:
  // below are arm positions used for vision behaviors (see Chapter 14)
  //              0    1    2    3    4    5    6    7    8   9 
  Data LeftSH;   770, 655, 776, 804, 858,1027,1216,1338,1628,1905
  Data LeftEL;  2208,2087,1947,2135,2208,2215,2175,2100,1900,1580
  Data LeftWR;  2096,2010,2065,1850,1710,1552,1445,1410,1350,1430
 
  Data RightSH; 1975,1975,1975,1831,1831,1667,1510,1336,1126, 847
  Data RightEL;  525, 850, 773, 781, 597, 597, 597, 758, 797,1127
  Data RightWR;  560, 540, 584, 642, 845, 924,1090,1090,1284,1270
  // initial array data for communication
  // Servo Positions
  Data P;       1270,1332,1350,1257,1350,1674,1400,1330,1400,1375,1375,1220,1630,1780
  // Data and Commands
  Data P;       0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
  Dim OrigPos[16]
  for i=0 to 15
    OrigPos[i]=P[i]
  next
  Data OOR; 25,4,5,6,7,8,9,10,19,20,21,22,23,24,25,35,36,37,38,39,51,52,53,66,67,68
  // general constants to make programs more readable and easier to write
  MaxRotLeftArm =1843
  MinRotLeftArm =1588
  MaxRotRightArm =1088
  MinRotRightArm = 800  
  LeftHandOpen = 1674
  LeftHandHalf = 1739
  LeftHandClosed = 2200
  RightHandOpen = 1220
  RightHandHalf = 1495
  RightHandClosed = 1292
  PickUp = 0
  Drop = 1
  WristForWave = 1160 //+440 for other position (right hand)
  LeftArmSafe = 1200
  RightArmSafe = 1525
  LeftLeftFinger=4
  LeftRightFinger=1
  LeftGrasp=16
  LeftDetectObject=8
  RightLeftFinger=64
  RightRightFinger=2
  RightGrasp=32
  RightDetectObject=128
  LtRot      =0
  LtShoulder =1
  LtElbow    =2
  LtWrist    =3
  LtWristLR  =4
  LtHand     =5
  RtRot      =6
  RtShoulder =7
  RtElbow    =8
  RtWrist    =9
  RtWristLR  =10
  RtHand     =11
  TurretHorz =12
  TurretVert =13
  GripperData =14
  USrangeData =15
  IRrangeData =16                                                      
  RangeLimit  =17
  RequestScan =18
  RequestClose=19
  RequestOpen=20
  RequestHome = 21
  RequestTerminate = 22  
  LeftHand = 1
  LeftArm = 1
  RightHand = 2
  RightArm = 2
  NotSeen = 0
  UnReachable = 3
  GreenObject = 1023306
  PinkObject =  5966794
  TurretCam = "Cam1 1"
  FrontCam = "Cam3 10"
  gosub HomeArms
return                                                   

InitCameras:
  Dim CntInfo[15,15]
  BMP="BMP"
return

InitVoiceRec:
  VoiceRec = "EditBox"
  AddEdit VoiceRec, 0,585,799
  AddEdit "Output", 0,550,799
  FocusEdit VoiceRec  
  LastMove=""
return

HomeArms:
  P[RequestHome]=1
  gosub MoveServos
return

ToTable:
  if P[GripperData]&LeftGrasp
    call Say("okay I will put it down",_normal)
    call DropObject(LeftArm)
  elseif P[GripperData]&RightGrasp
    call Say("okay I will put it down",_normal)
    call DropObject(RightArm)
  endif  
return

GiveToMe:
  if P[_GripperData]&LeftGrasp
    call RaiseArm(LeftArm)
    call Say("Take it please",normal)
    delay 500
    call OpenHand(LeftHand)
    delay 500
    gosub DropArms
  elseif P[GripperData]&RightGrasp
    call RaiseArm(RightArm)
    call Say("Take it please",_normal)
    delay 500
    call OpenHand(RightHand)
    delay 500
    gosub DropArms
  else
    call Say("Sorry", _sad)
    call Say("I don't have anything to give", _normal)     
  endif
return

sub DropObject(WhichArm) 
  temp1=0
  temp2=0
  if WhichArm=_LeftArm
    track = 1750 //left arm track to shared space
    call UpPos(_LeftArm)
    gosub MoveServos 
    P[_LtRot]=track
    gosub MoveServos
    call LeftArmForward(temp,_Drop)
  elseif WhichArm =_RightArm
    track = 830
    call UpPos(_RightArm)
    gosub MoveServos
    P[_RtRot]=track // track to shared space
    gosub MoveServos 
    call RightArmForward(temp,_Drop)
  endif
return
         
TurretDown:
  P[12]=1630    // set to your camera position
  P[13]=896
  gosub MoveServos
return   

TurretUp:
  P[12]=1630   // centered position
  P[13]=1655
  gosub MoveServos
return

PickUpAnyBottle:
  // Looks for both GREEN and PINK objects on table
  // if only one is found, picks it up
  // if two are seen, then asks which to pick up
  // (standard routine will be called when they answer GREEN or PINK)       
  gosub TurretDown
  call GetImage(TurretCam) 
  call FindObject(_PinkObject,whereX1,whereY1,track1,WhichArm1)
  call FindObject(_GreenObject,whereX2,whereY2,track2,WhichArm2)
  if WhichArm1 and (not WhichArm2)
    if WhichArm1 = _UnReachable
      call PickUpBottle(_PinkObject,found)
    else
      call Pickup(track1,WhichArm1,found)
    endif
  elseif (not WhichArm1) and WhichArm2
    if WhichArm2 = _UnReachable
      call PickUpBottle(_GreenObject,found)
    else
      call Pickup(track2,WhichArm2,found)
    endif
  elseif WhichArm1 and WhichArm2
    call Say("I see two bottles", _normal)
    delay 1000
    call Say("Which do you want me to pick up?",_normal)
  else
    call Say("I do not see a bottle", _sad)
  endif 
  gosub TurretUp
return 

sub PickUpBottle(TheColor,&found)
  // picks up the color specified and returns the object size and if found
  // if two bottles exist, it will pick up the first one found of correct color
  gosub TurretDown
  call GetImage(_TurretCam) 
  call FindObject(TheColor,whereX,whereY,track,WhichArm)
  if WhichArm = _UnReachable
    // drag bottle within range
    call Say("I see it but I cannot reach it",_normal)
    call Say("I need the hook",_normal)
    delay 1000     
    P[_RtRot]=     1400
    P[_RtShoulder]= 800
    P[_RtElbow]=    781
    P[_RtWrist]=   1119
    P[_RtHand]=    1220
    gosub MoveServos
    call Say("Please give me the hook",_normal)
    // wait for hook
    repeat
      gosub MoveServos
    until P[_GripperData]&_RightDetectObject
    call CloseHand(_RightHand,diameter,found)
    call Say("Thank you",_happy)
    delay 1000
    // no current checks to make sure hook obtained
    // add if desired
    // move hook into position    
    P[_RtShoulder]= 893
    P[_RtElbow]=   1027
    P[_RtWrist]=   1220
    P[_RtWristLR]= 1003
    gosub MoveServos
    P[_RtRot]=      800
    gosub MoveServos
    // push bottle 
    P[_RtWristLR]=1400
    gosub MoveServos
    // move away from object
    P[_RtRot] = 1304
    P[_RtWristLR]=1417
    gosub MoveServos
    // raise arm to give hook
    P[_RtRot]=     1400
    P[_RtShoulder]= 800
    P[_RtElbow]=    781
    P[_RtWrist]=   1119
    gosub MoveServos
    call Say("Please take the hook",_normal)
    delay 500
    call OpenHand(_RightHand)
    call Say("Thank you", _happy) 
    delay 1000 
    gosub DropArms 
    // now find the new location   
    gosub TurretDown
    call GetImage(_TurretCam) 
    call FindObject(TheColor,whereX,whereY,track,WhichArm)
    call Say("I hope I moved it enough",_happy)
  endif
  if WhichArm = _NotSeen
    call Say("I do not see the bottle you want",_sad) 
  else
    gosub TurretUp
    call Pickup(track,WhichArm,found)
  endif
return

sub Pickup(track,WhichArm,&found)
  // picks up any object with the arm/track specified
  // basically a utility routine for other pickup routines
  if WhichArm = _LeftArm   
    call Say("I can reach it with my left arm", _normal)
    call EmptyHand(_LeftArm) // make sure nothing in hand
    //call OpenHand(_LeftHand)
    // starting position
    call StartingPos(_LeftArm)
    gosub MoveServos
    // rotate to track
    P[_LtRot]=track
    gosub MoveServos
    call LeftArmForward(found,_PickUp) 
  elseif WhichArm = _RightArm
    call Say("I can reach it with my right arm", _normal)
    call EmptyHand(_RightArm) // make sure nothing in hand
    //call OpenHand(_RightHand)
    call StartingPos(_RightArm)
    gosub MoveServos
    P[_RtRot]=track
    gosub MoveServos
    call RightArmForward(found,_PickUp) 
  endif
  if not found 
    call Say("There was a problem",_sad)
    found = false   
  endif
return

sub EmptyHand(WhichHand)
  // if this hand holds something, them give it away
  if (WhichHand = _LeftHand) and (P[_GripperData]&_LeftGrasp)
    call RaiseArm(_LeftArm)
    call Say("Please hold this for me",_normal)
    delay 400
    call OpenHand(WhichHand)
    P[_LtWrist]=1291
    gosub MoveServos
  elseif (WhichHand=_RightHand)and(P[_GripperData]&_RightGrasp)
    call RaiseArm(_RightArm)
    call Say("Please hold this for me",_normal)
    delay 400
    call OpenHand(WhichHand)
    delay 200
    P[_RtWrist]=1220
    gosub MoveServos   
  endif   
return  
  
sub RaiseArm(WhichArm)  
  // raise arm to give bottle away
  if WhichArm = _RightArm
    P[_RtRot]=     1400
    P[_RtShoulder]= 800
    P[_RtElbow]=    781
    P[_RtWrist]=   1119
    P[_RtWristLR]= 1370
    gosub MoveServos
  elseif WhichArm = _LeftArm
    P[_LtRot]=      1307
    P[_LtShoulder]= 2000     
    P[_LtElbow]=     1940
    P[_LtWrist]=     1391
    P[_LtWristLR]=   1350
    gosub MoveServos
  endif 
return



sub StartingPos(WhichArm)
  if WhichArm = _LeftArm
    P[_LtShoulder] = LeftSH[0]
    P[_LtElbow] = LeftEL[0]
    P[_LtWrist] = LeftWR[0]
  elseif WhichArm = _RightArm
    P[_RtShoulder] = RightSH[0]
    P[_RtElbow] = RightEL[0]
    P[_RtWrist] = RightWR[0]
  endif
  gosub MoveServos
return

sub UpPos(WhichArm)
  if WhichArm = _LeftArm
    P[_LtShoulder] = LeftSH[0]
    P[_LtElbow] = 2100
    P[_LtWrist] = LeftWR[0]
  elseif WhichArm = _RightArm
    P[_RtShoulder] = RightSH[0]
    P[_RtElbow] = 600
    P[_RtWrist] = RightWR[0]
  endif
  gosub MoveServos
return



sub RotToOriginal(which)
  if which = _LeftArm
    P[_LtRot]=OrigPos[_LtRot]
    gosub MoveServos
  elseif which = _RightArm
    P[_RtRot]=OrigPos[_RtRot]
    gosub MoveServos
  endif
return
 
sub RotateRightArm(position)
  P[_RtRot]=RightArmPositions[position]
  gosub MoveServos
return

sub LeftArmForward(&found,action)
  // action can be PickUp or Drop
  found = false
  // starts at position 1 and moves to position 8 (max)
  for p = 1 to 8
    // move to next position                   
    if p>5 then P[_LtShoulder]+=20  // up slightly to prevent drag
    if (p=5) or (p=6) then P[_LtWrist]+=20
    gosub MoveServos 
    P[_LtShoulder]=LeftSH[p]
    P[_LtElbow]   =LeftEL[p]
    P[_LtWrist]   =LeftWR[p]
    gosub MoveServos
    if action = _PickUp // watch for object
      // check for object in hand
      if P[_GripperData]&_LeftDetectObject
        // object found, so edge forward 
        // and drop hand slightly
        P[_LtWrist]-= 50
        P[_LtShoulder]+= 70
        gosub MoveServos  
        //found = true
        call CloseHand(_LeftHand,diameter,found)
        // then raise slightly for move
        P[_LtWrist]+=80
        gosub MoveServos
        break
      endif
      // if not found yet, check for centering
      if P[_GripperData]&_LeftLeftFinger       
        // object on right, move left
        if P[_LtRot]>=_MinRotLeftArm+50
          P[_LtRot]-=50
          gosub MoveServos
        endif
      elseif P[_GripperData]&_LeftRightFinger
        // object on left, move right
        if P[_LtRot]<=_MaxRotLeftArm-50 
          P[_LtRot]+=50     
          gosub MoveServos 
        endif    
      endif
    endif
  next
  if action = _Drop
    call OpenHand(_LeftHand)
    call StartingPos(_LeftArm)
    gosub DropArms
  endif
return

sub RightArmForward(&found,action)
  // action can be PickUp or Drop
  // starts at position 1 and moves to position 8 (max)
  found = false
  for p = 1 to 8
    // move to next position
    if p>5 then P[_RtShoulder]-=20 // up slightly
    if (p=5) or (p=6) then P[_RtWrist]-=20
    gosub MoveServos  
    P[_RtShoulder]=RightSH[p]
    P[_RtElbow]   =RightEL[p]
    P[_RtWrist]   =RightWR[p]
    gosub MoveServos
    if action = _PickUp
      // check for object in hand
      if P[_GripperData]&_RightDetectObject
        // object found, so edge forward
        // and drop hand slightly
        P[_RtWrist]+=50
        P[_RtShoulder]-=70
        gosub MoveServos
        call CloseHand(_RightHand,diameter,found)
        // then raise for move
        P[_RtWrist]-=80
        gosub MoveServos
        break
      endif
      // if not found yet, check for centering
      if P[_GripperData]&_RightLeftFinger
        // object on left, move right
        if P[_RtRot]>=_MinRotRightArm+50
          P[_RtRot]-=50   
          gosub MoveServos
        endif
      elseif P[_GripperData]&_RightRightFinger
        // object on right, move left
        if P[_RtRot]<=_MaxRotRightArm-50 
          P[_RtRot]+=50     
          gosub MoveServos 
        endif    
      endif
    endif
  next
  if action = _Drop
    call OpenHand(_RightHand)
    call StartingPos(_RightArm)
    gosub DropArms
  endif 
return    

sub CloseHand(which,&amount,&object)
  object = false
  P[_RequestClose]=which  // close it till sensor is triggered
  gosub MoveServos
  if which=_LeftHand
    if P[_GripperData]&_LeftGrasp then object=true
    amount = P[_LtHand]
  elseif which = _RightHand
    if P[_GripperData]&_RightGrasp then object=true
    amount = P[_RtHand]
  endif
return

sub OpenHand(which)
  P[_RequestOpen]=which  
  gosub MoveServos
return

PrintColors:
  gosub TurretDown
  flip off
  ClearScr
  Print "Hold up two objects to be learned."
  delay 2000
  call GetImage(TurretCam) // image in Temp.BMP
  FitBmp "Temp"
  Print "Click object one"
  repeat
    ReadMouse x,y,b
  until b
  ReadPixel x,y,Color1
  delay 1000                   
  Print "Click object two"
  repeat
    ReadMouse x,y,b
  until b
  ReadPixel x,y,Color2
  print "Color1 = ",Color1
  print "Color2 = ",Color2
  gosub TurretUp
  print "Program terminated"
return

CheckForVoiceCommand:
  FocusEdit VoiceRec
  VoiceIn = ""
  if EditChanged(VoiceRec)
     VoiceIn = Upper(GetEdit(VoiceRec))
     SetEdit VoiceRec,""
     if VoiceIn<>"" then SetEdit "Output",VoiceIn
  endif
return


sub FindObject(color,&whereX,&whereY,&track,&WhichArm) 
  // use 15,15 grid and returns x,y and track and what arm to use
  dx=800/15 // scrn resolution is 800x600
  dy=600/15 // 15x15 grid
  call FindColorInBMP("Temp",color,Found,SecCnt)
  if Found
    whereX=Found#15                                    
    whereY=Found/15
    if whereX >= 7
      // use right arm
      WhichArm = _RightArm
      angle = RtoD(atan2(16-whereX,18-whereY))
      track = 10*angle+308 
      if track >_MaxRotRightArm then track=_MaxRotRightArm
      if track <_MinRotRightArm then track=_MinRotRightArm   
    else
      // use left arm
      WhichArm = _LeftArm
      angle = RtoD(atan2(whereX+2,18-whereY))
      track = 2447-11*angle 
      // limit track
      if track >_MaxRotLeftArm then track=_MaxRotLeftArm
      if track <_MinRotLeftArm then track=_MinRotLeftArm   
    endif
    // uncomment below to view object for adjusting camera
    // gosub ShowGrid 
    // override left or right if object unreachable
    for i=1 to OOR[0]
      if Found = OOR[i]
        WhichArm = _UnReachable
        break
      endif
    next
  else 
    WhichArm = _NotSeen
  endif 
return

TakeThis:
  // ensure right hand is open
  call OpenHand(RightHand)
  call RaiseArm(RightArm)
  call Say("Give it to me",normal)
  // wait for cross beam in hand to trigger
  repeat
    gosub MoveServos
    if P[GripperData]&RightRightFinger
      P[RtWristLR]=1132
    elseif P[GripperData]&RightLeftFinger
      P[RtWristLR]=1568
    endif
  until P[GripperData]&RightDetectObject
  call CloseHand(RightHand,diameter,found)
  //if P[GripperData]&RightGrasp
  if found
    call Say("I got it",happy)  
  else
    call Say("Sorry I did not get it", sad)
  endif
  gosub DropArms
return

MoveForward:
  rForward 30
  LastMove = "Forward"
return

MoveBackward:
  rForward -30
  LastMove = "Backward"
return

TurnNorth:
  rCommand(TurnToHalfAngle,0)
return

TurnSouth:
  rCommand(TurnToHalfAngle,180/2)
return

TurnEast:
  rCommand(TurnToHalfAngle,90/2)
return

TurnWest:
  rCommand(TurnToHalfAngle,270/2)
return

MoveToDest:  // kitchen test
  rTurn -40
  for ti=1 to 5
    rForward 60
  next
  delay 5000
  rTurn 180
  for ti=1 to 5
    rForward 60
  next
  rTurn -140    
return

DoScan:
  call Say("Scanning out about three feet",normal)
  P[17]=36
  P[18]=2 // US only
  gosub MoveServos
  flip off
  clearscr
  linewidth 5
  Circle 350,10,450,110
  line 400,60,400,110
  Call Say("Here is where I see objects",noface)
  mask=1
  for ti=0 to 6
    if P[17]&mask
      print ti
      Call MyCircle(XforScan[ti],YforScan[ti])         //  ti*40+280
    endif
    mask = mask*2
  next
  delay 500
  Call Say("Just say FINISHED when you are ready to continue",noface)
  repeat
    gosub CheckForVoiceCommand
  until Instring(VoiceIn, "FINISH")
  flip on
  delay 1000
  call Say("My many sensors makes me cool", happy)
return

sub MyCircle(x,y)
  r=20
  circle x-r,y-r,x+r,y+r,black,black
return

GuardTheHouse:
  // customize to meet your needs
  // robot might wander though house checking for motion
  // perhaps even taking pictures periodically
  // then sending an email to keep you updated
return

Greeting:
  call Say("My name is Arlo",normal)
  call Say("I am the robot you have always wanted",happy)
  LastMove = "Who"
return

DoWave:
  P[RtShoulder]= 800
  P[RtElbow]=    697
  P[RtWrist]=    950
  //gosub MoveServos
  // close hand
  P[11] = RightHandClosed
  gosub MoveServos
  // wave 
  for ti= 1 to 3
    P[10] = WristForWave
    gosub MoveServos
    P[10]+=440
    gosub MoveServos
  next
  gosub DropArms
  call Say("How was that",normal)
return


DropArms:
  P[0]=OrigPos[0]
  P[6]=OrigPos[6]
  gosub MoveServos
  for ti=1 to 4
    P[ti]=OrigPos[ti]
  next
  for ti=7 to 10
    P[ti]=OrigPos[ti]
  next
  for ti=12 to 14
    P[ti]=OrigPos[ti]
  next  
  gosub MoveServos
return  

MoveServos:
  mWrite P,"DataReady"
  FileRename("DataReady","ProcessNow")
  repeat
  until FileExists ("DataReady")
  delay 10  // may be necessary on some computers
  mRead P,"DataReady"  
return

TurnLeft:
  rTurn -40
  LastMove = "Left"
return

TurnRight:
  rTurn 40
  LastMove = "Right"
return

DoMore:
  if LastMove = "Right"
     rTurn 10
  elseif LastMove = "Left"
     rTurn -10
  elseif LastMove = "Forward"
     rForward 10
  elseif LastMove = "Backward"
     rForward -10
  endif
return

DoLess:
  if LastMove = "Right"
    rTurn -10
  elseif LastMove = "Left"
    rTurn 10
  elseif LastMove = "Forward"
    rForward -10
  elseif LastMove = "Backward"
    rForward 10
  endif
return

DoAgain:
  if LastMove = "Right"
    gosub TurnRight
  elseif LastMove = "Left"
    gosub TurnLeft
  elseif LastMove = "Forward"
    gosub MoveForward
  elseif LastMove = "Backward"
    gosub MoveBackward
  elseif LastMove = "Wave"
    gosub DoWave
  elseif LastMove = "Who"
    gosub Greeting
  elseif LastMove = "Scan"
    gosub DoScan
  endif
return

IdentifyObject:
  if P[GripperData]&LeftGrasp 
    P[LtRot]=      1307
    P[LtShoulder]= 2000     
    P[LtElbow]=     1717
    P[LtWrist]=     1991
    P[LtWristLR]=   1350
    gosub MoveServos 
    P[LtHand]=1686 // ensure bottle in palm of hand
    gosub MoveServos
    call CloseHand(LeftHand) 
    // look at hand
    P[LtWristLR]= 1131
    gosub MoveServos
    P[TurretHorz]= 2352
    P[TurretVert]= 1300
    gosub MoveServos
    call GetImage(TurretCam)
    call FindColorInBMP("Temp",GreenObject,Found,SecCnt)
    if Found
      if P[LtHand] >1900 
        call Say("It appears to be object number one", normal)
      else
        call Say("It appears to be object number two", normal)
      endif
    else
      call FindColorInBMP("Temp",PinkObject,Found,SecCnt)
      if Found
        if P[LtHand]>1810
          call Say("It appears to be object number three", normal)
        else
          call Say("It appears to be object number four", normal)
        endif
      else
        call Say("I have no idea what this is",normal)
      endif
    endif  
  elseif P[GripperData]&RightGrasp
    P[RtRot]=     1318
    P[RtShoulder]= 800
    P[RtElbow]=    996
    P[RtWrist]=    678
    P[RtWristLR]= 1406
    gosub MoveServos
    P[RtHand]=1281 // ensure bottle in palm of hand 
    gosub MoveServos
    call CloseHand(RightHand) 
    // look at hand
    P[RtWristLR]= 1592
    gosub MoveServos
    P[TurretHorz]= 822
    P[TurretVert]= 1300
    gosub MoveServos
    call GetImage(TurretCam)
    call FindColorInBMP("Temp",GreenObject,Found,SecCnt)
    if Found
      // green object
      if P[RtHand]<1450 
        call Say("It appears to be object number two",_happy)
      else
        call Say("It appears to be object number one",_happy)
      endif
    else
      call FindColorInBMP("Temp",PinkObject,Found,SecCnt)
      if Found
        // Pink object
        if P[RtHand]<1380 
          call Say("It appears to be object number four",_happy)
        else
          call Say("It appears to be object number three",_happy)
        endif 
      else
        call Say("I have no idea what this is",normal)
      endif
    endif       
  endif 
  delay 1000
  gosub DropArms
return

LearnColors: // learn two colors
  flip off
  call Say("Sit two colors on the table for me to learn", normal)
  gosub TurretDown
  delay 1000
  call GetImage(TurretCam)
  // display image
  FitBmp "Temp"
  call Say("Click the green object", noface)
  repeat
    ReadMouse x,y,b
  until b
  // record objects color in col
  ReadPixel x,y,GreenObject
  delay 1000                   
  call Say("Click the pink object", noface)
  repeat
    ReadMouse x,y,b
  until b
  // record objects color in col
  ReadPixel x,y,PinkObject
  call Say("Here are the colors chosen if you wish to code" + \
       " them into the program to make them the defaults", noface) 
  print "GREEN = ",GreenObject
  print "PINK =  ",PinkObject
  call Say("Click or touch the screen to continue", noface)
  gosub TurretUp
  repeat
    ReadMouse x,y,b
  until b
  flip on
  ClearScr 
  gosub DrawFace
return

sub FindColorInBMP(TheFileName,TheColor,&Found,&SecCnt)     
  BMPfindClr TheFileName,TheColor,Found,SecCnt,.1,.5,15,CntInfo
  if Found<0 then Found = 0 // sector 0 is off the table
  if SecCnt>10 then Found = 0
return

AdjustCamera:
  gosub TurretDown
  call Say("I will take ten pictures for you", normal)
  call Say("Adjust the camera to center the picture", normal)
  for aj=1 to 10
    call GetImage(TurretCam)
    FitBMP "Temp"
    flip
  next 
  gosub TurretUp
  clearscr
  gosub DrawFace 
return

WatchObject:
  call GetImage(FrontCam)
  BMPfindClr "Temp",PinkObject,Found,SecCnt,.1,.5,9,CntInfo
  if Found>=0 // command uses -1 for not found
    col = PinkObject
    call Say("I see a pink bottle",happy)
  else
    //call FindColorInBMP("Temp",PinkObject,Found,SecCnt)
    BMPfindClr "Temp",GreenObject,Found,SecCnt,.15,.1,9,CntInfo
    if Found >=0 
      col = GreenObject
      call Say("I see a green bottle", happy)
    else
      call Say("I do not see any object I know", normal)
      return
    endif
  endif
  call Say("Move the object slowly and keep it in my view",normal)
  call Say("Just say FINISHED when you are ready to move on", normal)
  while True
    call GetImage(FrontCam)
    // uncomment line below to see image to check proper camera.
    // you will ONLY see the image - no commands accepted
    // clearScr\FitBmp "Temp" \flip\wend
    BMPfindClr "Temp",col,Found,SecCnt,.2,.05,9,CntInfo
    if Found>=0
      // determine grid coordinates of found block
      x=Found#9
      y=Found/9
      horz = 92-x*23
      vert = -35+y*9
      gosub Eyes
      gosub CheckForVoiceCommand   
      if InString(VoiceIn, "FINISH")
        horz = 0
        vert = 0
        gosub Eyes
        call Say("Okay what is next",happy)
        break
      endif     
    endif
  wend
return

sub GetImage(Command)  
  FileDelete("Temp.jpg")
  // tell the Utility to take the picture
  SetCBtext(Command) 
  FileRename ("RBsTurn.txt","SensorsTurn.txt")  
  FileDelete("Temp.bmp")
  // wait for handshake
  while !FileExists("Temp.jpg")
  wend
  delay 100  
  ToBmp "Temp.jpg"
return

sub TurnToAngle(heading)
  rCommand(TurnToHalfAngle,heading/2)
return

sub FollowWall(side, &EOW)
  WallDist = 16
  if side = _OnLeft
    RangeDir = -90
    TurnAway = 1
  elseif side = _OnRight
    RangeDir = 90
    TurnAway = -1
  else
    EOW = -1  // indicate error
    return    // invalid parameter
  endif
  EOW = false
  while not EOW
    r1=rRange(RangeDir)
    for i=1 to 20 
      rForward 1
      r2=rRange(RangeDir)
      if r2>(WallDist+20)  // doorway seen on left  
        EOW=_Door
        break
      endif    
      if rFeel()&4  // blocked in front 
        EOW = _Wall
        break
      endif         
    next 
    if not EOW 
      // make corrections
      change = r2-r1
      xyString 10,10, change;r2;" "
      if change != 0
        // first priority - stay parallel with wall
        for j= 0 to abs(change) // adjust proportional to error
          rTurn -sign(change)*TurnAway
        next  
      else
        // robot is parallel - so slowly correct dist from wall
        for j=1 to 3  // controls how fast to correct
          if r2>WallDist then rTurn -TurnAway
          if r2<WallDist then  rTurn TurnAway
        next
      endif
    endif
  wend
return



DrawFace:
  //controlled by these ROOT variables (horz,vert,size,brows,mouth)  
  gosub Eyes
  LineWidth 1
  // draw nose
  rectangle 340,365,455,400,white,white
  if _mouth = 5
    arc 349,360,453,399,2.9,3.65,1,black
  else
    arc 350,360,450,400,2.9,3.65,3,black
  endif
  line 360,363,390,200,3,black
  line 437,362,410,200,3,black
  //cheeks
  rectangle 90,340,340,250,white,white
  rectangle 730,340,458,250,white,white
  if _mouth = 3
    arc 100,330,350,180,4.5,1.5,2,black
    arc 700,330,450,180,3.4,1.5,2,black
  else
    arc 100,330,350,200,4.5,1.5,5,darkgray
    arc 700,330,450,200,3.4,1.5,5,darkgray
  endif
  flip
  // draw proper mouth
  if _mouth = 0
    gosub Normal
  elseif _mouth = 1
    gosub Smile
  elseif _mouth = 2
    gosub Frown
  elseif _mouth = 3
    gosub Constant
  elseif _mouth = 4
    gosub Vsound
  elseif _mouth = 5 
    gosub Osound
  endif
  flip
return
  
DemoFace:
  call Say("okay",normal) \delay 100
  call Say("I can do that for you",happy)   
  call Say("This routine shows how to make the robot say what you want",normal) 
  for horz=0 to -100
    gosub DrawFace
  next
  call Say("I can be angry",angry) \delay 2000
  horz=0
  call Say("And I can be Happy",happy) \delay 2000
  call Say("Or sad", sad)\delay 2000 
  call Say("Even surprised", normal)
  call Say("",surprise)\delay 2000
  call Say("Pretty good huh", happy)\delay 2000
  horz=100 
  gosub DrawFace
  delay 1000
  horz=0
  gosub DrawFace    
return

sub Say(s, style)
  // alter face parameters for each style
  // horz controls left and right position of eyes: -100[screen left] to 100
  // vert controls up/down position of eyes(-30 up to 30 down)
  // size controls the eye's height (squint, etc) (-20 to +20)
  // brows (0,1,2) indicates normal, down and up
  // mouth controls mouth movement type (0-normal, 1-smile, 2-frown
  //   3-constant, 4-vowel (all but O), 5-O sound 
  // These emotions are just a first attempt - play with various ideas and 
  // improve or add to them to meed your needs
  // NOTE: the value of SpeedDelay must be set ONCE to handle the timing for
  //   your machine.  Once set, the graphics and voice should be synchronized.
  // Note: Use style of 6 if you want to set ALL of your own parameters on the fly,
  //       or create special styles of your own
  if style = _normal
   // _horz = 0        // allows user to control the eye position
   // _vert = 0        // uncomment if you wish
    _size = 0
    _brows = 0
    _mouth = 0 
  elseif style = _angry
   // _horz = 0
   // _vert = 0
    _size = -5
    _brows = 1
    _mouth = 0 
  elseif style = _sad
    _horz = 0
    _vert = +25
    _size = 0
    _brows = 1
    _mouth = 2     
  elseif style = _happy
   // _horz = 0
   // _vert = 0
    _size = 5
    _brows = 0
    _mouth = 1
  elseif style = _surprise
    _horz = 0
    _vert = 0
    _size = 20
    _brows = 2
    _mouth = 5
  endif 
  temps=s
  if style!=_noface then gosub Eyes
  s=temps
  setcbtext("Say,"+s) // tell the Interface program what to read
   // now trigger  utility  to perform 
   filerename ("RBsTurn.txt","SensorsTurn.txt")
   // produce animation if requested
   if style!=_noface  // animate if pause>0 otherwise, just voice
     answer=0
     LineWidth 20
     if s="" 
       s="*"
     else
       s=s+" *"
     endif
     s=Lower(s)  
     mfromstring words,s," "
     for i=0 to _MaxWords-1
       State=""
       if words[i]="*" then break
       // animate next word
       for j=1 to Length(words[i])
         L=SubString(words[i],j,1)
         call IsVowel(L,answer)
         if (answer and (State="C"))  or ((!answer) and (State="V")) or (State="")
           if answer
             if L="o"
               _mouth=5\gosub DrawFace
             elseif !((L="e") and (Length(words[i])=j))
               _mouth=4\gosub DrawFace
             endif
             State="V"
           else
             _mouth=3\gosub DrawFace
             State="C"
           endif
         endif
       next
     next
     mouth=0\gosub DrawFace
     // reset mouth    
     if style = _normal
       _mouth = 0\gosub DrawFace
     elseif style = _happy
       _mouth = 1\gosub DrawFace
     elseif style = _sad
       _mouth = 2\gosub DrawFace
     elseif style = _surprise
       _mouth = 5\gosub DrawFace   
     elseif style = _angry
       _mouth = 0\gosub DrawFace   
     endif 
     flip
   endif 
   // continue waiting to ensure utility has finished speaking
   while !fileexists("RBsTurn.txt") 
   wend 
return




Eyes:
  // controlled by ROOT variables (horz,vert,size)
  Thorz=_OldHorz
  Tvert=_OldVert
  repeat
    // clear eye area
    rectangle 10,50,350,200,white,white
    rectangle 450,50,790,200,white,white 
    if Thorz<_horz then Thorz++
    if Thorz>_horz then Thorz--
    if Tvert<_vert then Tvert++
    if Tvert>_vert then Tvert--
    s=_size
    vt=0\vb=0
    if _vert>0 then vb=-_vert/5\vt=_vert/5
    if _vert<0 then vt=-_vert/5\vb=_vert/5
    LineWidth 30
    SetColor Black
    circle 50,95-s,350,225+s
    circle 450,95-s,750,225+s 
    LineWidth 5
    er=50
    circle Thorz+200-er,Tvert+160-er+vt,Thorz+200+er,Tvert+160+er+vb,blue,lightblue
    circle Thorz+600-er,Tvert+160-er+vt,Thorz+600+er,Tvert+160+er+vb,blue,lightblue 
    er=25
    circle Thorz+200-er,Tvert+160-er+vt,Thorz+200+er,Tvert+160+er+vb,black,black   
    circle Thorz+600-er,Tvert+160-er+vt,Thorz+600+er,Tvert+160+er+vb,black,black     
    LineWidth 35
    arc 50,95-s,350,225+s
    arc 450,95-s,750,225+s
    LineWidth 80
    SetColor white
    Arc 10,55-s,390,265+s   
    Arc 410,55-s,790,265+s
    line 60,55,200,40,20
    lineto 330,45,20
    line 740,55,600,40,20
    lineto 470,45,20 
    setcolor Black
    if _brows = 0   // normal
      line 60,85,200,65,20
      lineto 330,75,20
      line 740,85,600,65,20
      lineto 470,75,20
    elseif _brows = 1 // anger
      line 60,80,330,90,20
      line 470,90,740,80,20 
    elseif _brows = 2 // surprise
      line 60,55,200,40,20
      lineto 330,45,20
      line 740,55,600,40,20
      lineto 470,45,20
    endif          
    flip
  until (Thorz=_horz) and (Tvert=_vert)
  _OldHorz = Thorz
  _OldVert = Tvert
return

sub IsVowel(c,&answer)
  if c="a" or c="e" or c="i" or c="o" or c="u" or c="y"
    answer= true
  else
    answer= false
  endif
return

Smile:
  // 1
  linewidth 20
  rectangle 180,475,610,550,White,White
  line 220,475,280,500
  lineto 520,500
  lineto 580,475
  flip
return

Normal:
  // 0
  linewidth 20
  rectangle 180,470,610,550,White,White
  line 200,500,600,500
  flip
return

Frown:
  // 2
  linewidth 20
  rectangle 180,470,610,550,White,White
  line 200,520,240,500
  lineto 560,500
  lineto 600,520
  flip
return

Constant:
  // 3
  linewidth 10
  rectangle 180,470,610,550,White,White
  circle 200,500,600,510,black,red
  flip
  delay _SpeechDelay
return

Vsound:
  // 4
  linewidth 10
  rectangle 180,470,610,550,White,White
  //circle 300,395,500,430,black,red
  arc 220,490,580,505,3.1633,3.09
  arc 220,490,580,530,3.1,3.24
  floodfill2 500,510,red
  flip
  delay 2*_SpeechDelay
return

Osound:
  // 5
  linewidth 10
  rectangle 180,470,610,550,White,White
  circle 220,500,580,510,black,red
  flip
  delay _SpeechDelay/2
  rectangle 180,470,610,550,White,White
  circle 290,505,510,530,black,red
  flip
  delay _SpeechDelay*2
  //rectangle 180,480,610,550,White,White
  //circle 220,500,580,510,black,red
  //flip
  delay _SpeechDelay/2
return

ShowGrid:
  // used for debugging in FindObject
  FitBMP "Temp"
  for i=0 to 800 step 800/15 
    line i,0,i,600,1,LightBlue
  next
  for i=0 to 600 step 600/15
    line 0,i,800,i,1,LightBlue
  next  
  // use to help find angles for calculations
  print whereX;whereY;track;WhichArm;Found
  flip 
end 





